> For the complete documentation index, see [llms.txt](https://headless.intelligems.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://headless.intelligems.io/latest-1.2.19/reference/hooks/cart-and-checkout-hooks.md).

# Cart & Checkout Hooks

## `useIgCart()`

Use this hook if your site manages user carts through the Storefront **Cart** API.

Requires the `cartOrCheckoutToken` (cart ID). The hook will add cart attributes needed for experiments and optionally backfill currency based on the cart.

Returns a `wrapCustomAttributes` function. This function will add Intelligems-required line item properties to any existing line item properties (for example, for shipping tests).

<pre class="language-typescript" data-overflow="wrap"><code class="lang-typescript">interface WrapStorefrontItemCustomAttributesParams {
  productId?: string;
  variantId?: string;
  subscribeAndSave?: boolean;
  customAttributes?: {
    key: string;
    value: string;
  }[] | null;
};

interface WrapStorefrontItemCustomAttributesResponse {
  key: string;
  value: string;
}[];

<strong>const useIgCart: (cartOrCheckoutToken?: string | null) => {
</strong>  isReady: boolean;
  wrapCustomAttributes: (
    options: WrapStorefrontItemCustomAttributesParams
  ) => WrapStorefrontItemCustomAttributesResponse;
};
</code></pre>

## `useIgCartAttributes()`

Returns the attribute array you can attach when creating or updating carts in custom Storefront API flows.

```typescript
const useIgCartAttributes: () => {
  isReady: boolean;
  attributes: { key: string; value: string }[];
};
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://headless.intelligems.io/latest-1.2.19/reference/hooks/cart-and-checkout-hooks.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
